/* cheese-countdown.c generated by valac 0.17.7, the Vala compiler
 * generated from cheese-countdown.vala, do not modify */

/*
 * Copyright © 2010 Yuvaraj Pandian T <yuvipanda@yuvi.in>
 * Copyright © 2010 daniel g. siegel <dgsiegel@gnome.org>
 * Copyright © 2008 Filippo Argiolas <filippo.argiolas@gmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <gio/gio.h>


#define CHEESE_TYPE_COUNTDOWN (cheese_countdown_get_type ())
#define CHEESE_COUNTDOWN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CHEESE_TYPE_COUNTDOWN, CheeseCountdown))
#define CHEESE_COUNTDOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CHEESE_TYPE_COUNTDOWN, CheeseCountdownClass))
#define CHEESE_IS_COUNTDOWN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CHEESE_TYPE_COUNTDOWN))
#define CHEESE_IS_COUNTDOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CHEESE_TYPE_COUNTDOWN))
#define CHEESE_COUNTDOWN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CHEESE_TYPE_COUNTDOWN, CheeseCountdownClass))

typedef struct _CheeseCountdown CheeseCountdown;
typedef struct _CheeseCountdownClass CheeseCountdownClass;
typedef struct _CheeseCountdownPrivate CheeseCountdownPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CheeseCountdown {
	GObject parent_instance;
	CheeseCountdownPrivate * priv;
	gboolean running;
};

struct _CheeseCountdownClass {
	GObjectClass parent_class;
};

struct _CheeseCountdownPrivate {
	ClutterText* countdown_actor;
};

typedef void (*CheeseCountdownCountdownCallback) (void* user_data);

static gpointer cheese_countdown_parent_class = NULL;
static CheeseCountdownCountdownCallback cheese_countdown_completed_callback;
static gpointer cheese_countdown_completed_callback_target;
static GDestroyNotify cheese_countdown_completed_callback_target_destroy_notify;
static CheeseCountdownCountdownCallback cheese_countdown_completed_callback = NULL;
static gpointer cheese_countdown_completed_callback_target = NULL;
static GDestroyNotify cheese_countdown_completed_callback_target_destroy_notify = NULL;
static gint cheese_countdown_current_value;
static gint cheese_countdown_current_value = 0;
static gulong cheese_countdown_signal_id;
static gulong cheese_countdown_signal_id = 0UL;
static ClutterAnimation* cheese_countdown_anim;
static ClutterAnimation* cheese_countdown_anim = NULL;
static GSettings* cheese_countdown_settings;
static GSettings* cheese_countdown_settings = NULL;

GType cheese_countdown_get_type (void) G_GNUC_CONST;
#define CHEESE_COUNTDOWN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CHEESE_TYPE_COUNTDOWN, CheeseCountdownPrivate))
enum  {
	CHEESE_COUNTDOWN_DUMMY_PROPERTY
};
CheeseCountdown* cheese_countdown_new (ClutterText* countdown_actor);
CheeseCountdown* cheese_countdown_construct (GType object_type, ClutterText* countdown_actor);
static void cheese_countdown_fade_out (CheeseCountdown* self);
static void cheese_countdown_fade_in (CheeseCountdown* self);
void cheese_countdown_start (CheeseCountdown* self, CheeseCountdownCountdownCallback completed_callback, void* completed_callback_target);
void cheese_countdown_stop (CheeseCountdown* self);
static void cheese_countdown_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


CheeseCountdown* cheese_countdown_construct (GType object_type, ClutterText* countdown_actor) {
	CheeseCountdown * self = NULL;
	ClutterText* _tmp0_;
	ClutterText* _tmp1_;
	GSettings* _tmp2_;
	g_return_val_if_fail (countdown_actor != NULL, NULL);
	self = (CheeseCountdown*) g_object_new (object_type, NULL);
	_tmp0_ = countdown_actor;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->countdown_actor);
	self->priv->countdown_actor = _tmp1_;
	_tmp2_ = g_settings_new ("org.gnome.Cheese");
	_g_object_unref0 (cheese_countdown_settings);
	cheese_countdown_settings = _tmp2_;
	return self;
}


CheeseCountdown* cheese_countdown_new (ClutterText* countdown_actor) {
	return cheese_countdown_construct (CHEESE_TYPE_COUNTDOWN, countdown_actor);
}


/**
   * Fade the countdown text out, over 500 milliseconds.
   *
   * Once the fade-out is complete, this method calls fade_in().
   */
static void cheese_countdown_fade_out (CheeseCountdown* self) {
	ClutterText* _tmp0_;
	ClutterAnimation* _tmp1_ = NULL;
	ClutterAnimation* _tmp2_;
	ClutterAnimation* _tmp3_;
	gulong _tmp4_ = 0UL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->countdown_actor;
	_tmp1_ = clutter_actor_animate ((ClutterActor*) _tmp0_, (gulong) CLUTTER_LINEAR, (guint) 500, "opacity", 0, NULL);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (cheese_countdown_anim);
	cheese_countdown_anim = _tmp2_;
	_tmp3_ = cheese_countdown_anim;
	_tmp4_ = g_signal_connect_after (_tmp3_, "completed", (GCallback) cheese_countdown_fade_in, self);
	cheese_countdown_signal_id = _tmp4_;
}


/**
   * Decrement the countdown text and fade it in, over 500 milliseconds.
   *
   * Once the fade-in is complete, this method calls fade_out().
   */
static void cheese_countdown_fade_in (CheeseCountdown* self) {
	gint _tmp0_;
	ClutterText* _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gint _tmp6_;
	ClutterText* _tmp7_;
	ClutterAnimation* _tmp8_ = NULL;
	ClutterAnimation* _tmp9_;
	ClutterAnimation* _tmp10_;
	gulong _tmp11_ = 0UL;
	g_return_if_fail (self != NULL);
	_tmp0_ = cheese_countdown_current_value;
	if (_tmp0_ <= 0) {
		CheeseCountdownCountdownCallback _tmp1_;
		void* _tmp1__target;
		_tmp1_ = cheese_countdown_completed_callback;
		_tmp1__target = cheese_countdown_completed_callback_target;
		_tmp1_ (_tmp1__target);
		self->running = FALSE;
		return;
	}
	_tmp2_ = self->priv->countdown_actor;
	_tmp3_ = cheese_countdown_current_value;
	_tmp4_ = g_strdup_printf ("%i", _tmp3_);
	_tmp5_ = _tmp4_;
	clutter_text_set_text (_tmp2_, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = cheese_countdown_current_value;
	cheese_countdown_current_value = _tmp6_ - 1;
	_tmp7_ = self->priv->countdown_actor;
	_tmp8_ = clutter_actor_animate ((ClutterActor*) _tmp7_, (gulong) CLUTTER_LINEAR, (guint) 500, "opacity", 255, NULL);
	_tmp9_ = _g_object_ref0 (_tmp8_);
	_g_object_unref0 (cheese_countdown_anim);
	cheese_countdown_anim = _tmp9_;
	_tmp10_ = cheese_countdown_anim;
	_tmp11_ = g_signal_connect_after (_tmp10_, "completed", (GCallback) cheese_countdown_fade_out, self);
	cheese_countdown_signal_id = _tmp11_;
}


/**
   * Start the countdown, using the countdown-duration GSetting for the time.
   *
   * @param completed_callback the callback to call upon countdown completion
   */
void cheese_countdown_start (CheeseCountdown* self, CheeseCountdownCountdownCallback completed_callback, void* completed_callback_target) {
	CheeseCountdownCountdownCallback _tmp0_;
	void* _tmp0__target;
	GSettings* _tmp1_;
	gint _tmp2_ = 0;
	ClutterText* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = completed_callback;
	_tmp0__target = completed_callback_target;
	(cheese_countdown_completed_callback_target_destroy_notify == NULL) ? NULL : (cheese_countdown_completed_callback_target_destroy_notify (cheese_countdown_completed_callback_target), NULL);
	cheese_countdown_completed_callback = NULL;
	cheese_countdown_completed_callback_target = NULL;
	cheese_countdown_completed_callback_target_destroy_notify = NULL;
	cheese_countdown_completed_callback = _tmp0_;
	cheese_countdown_completed_callback_target = _tmp0__target;
	cheese_countdown_completed_callback_target_destroy_notify = NULL;
	_tmp1_ = cheese_countdown_settings;
	_tmp2_ = g_settings_get_int (_tmp1_, "countdown-duration");
	cheese_countdown_current_value = _tmp2_;
	self->running = TRUE;
	_tmp3_ = self->priv->countdown_actor;
	clutter_actor_show ((ClutterActor*) _tmp3_);
	cheese_countdown_fade_in (self);
}


/**
   * Stop the countdown, for example if it was interrupted by the user.
   */
void cheese_countdown_stop (CheeseCountdown* self) {
	ClutterText* _tmp0_;
	ClutterAnimation* _tmp1_;
	gulong _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->countdown_actor;
	clutter_actor_hide ((ClutterActor*) _tmp0_);
	_tmp1_ = cheese_countdown_anim;
	_tmp2_ = cheese_countdown_signal_id;
	g_signal_handler_disconnect (_tmp1_, _tmp2_);
	self->running = FALSE;
}


static void cheese_countdown_class_init (CheeseCountdownClass * klass) {
	cheese_countdown_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CheeseCountdownPrivate));
	G_OBJECT_CLASS (klass)->finalize = cheese_countdown_finalize;
}


static void cheese_countdown_instance_init (CheeseCountdown * self) {
	self->priv = CHEESE_COUNTDOWN_GET_PRIVATE (self);
}


static void cheese_countdown_finalize (GObject* obj) {
	CheeseCountdown * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CHEESE_TYPE_COUNTDOWN, CheeseCountdown);
	_g_object_unref0 (self->priv->countdown_actor);
	G_OBJECT_CLASS (cheese_countdown_parent_class)->finalize (obj);
}


GType cheese_countdown_get_type (void) {
	static volatile gsize cheese_countdown_type_id__volatile = 0;
	if (g_once_init_enter (&cheese_countdown_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CheeseCountdownClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cheese_countdown_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CheeseCountdown), 0, (GInstanceInitFunc) cheese_countdown_instance_init, NULL };
		GType cheese_countdown_type_id;
		cheese_countdown_type_id = g_type_register_static (G_TYPE_OBJECT, "CheeseCountdown", &g_define_type_info, 0);
		g_once_init_leave (&cheese_countdown_type_id__volatile, cheese_countdown_type_id);
	}
	return cheese_countdown_type_id__volatile;
}



